ScriptVersion := "0.98"
	/*
	< Appifyer > (alpha)
	Author: Simon Strålberg [sumon @ Autohotkey forums, simon . stralberg @ gmail . com]
	Autohotkey version: AHK_L (Unicode, x32)
	Dependencies:
		- AHK_L
		- Notify.ahk by gwarble & more [http://www.autohotkey.com/forum/viewtopic.php?t=48668]
		- Ini.ahk by Tuncay [http://www.autohotkey.com/forum/viewtopic.php?p=280883]
		- AddGraphicButton () by Corrupt [http://www.autohotkey.com/forum/topic4047.html]
		- TT.ahk (?)
		
	CHANGELOG:
	v.
		- 0.98 Added update for all apps & Appifyer. Trying to launch a running app only activates it. Added fast access to Settings, and MClick on Windows Start button brings up App menu.
		- 0.97b Trimmed winkey into the "hotkey" value
		- 0.97 Added basic Settings/Help tabs, fixed an issue where non-existing icon crashed the script, Slightly improved Appify:, fixed a crash caused by a removed app.
		- 0.96 Rewritten for nicer code, proper ini system, GUI saves flawlessly. Hotkey behaviour is fine. Added "Modes".
		- 0.91 a proper INI system, Settings, update, etc.

	TODO:
		- Add "TimesRun" counter.
		- Add updating
		- Add automatic (or semiautomatic) adding of apps [Check]
		- Fix the import/export of profiles
		
	WISHLIST:
		- Add Appifyer settings [Check]
		- Add scriptlet support & holder
		- [] Add hotstrings/gestures/launchfield?
		
	BUGS:
		- There can be variants of section like App_Name, App Name, which causes conflict.
		- AppifyerSettings doesn't get appropiately saved

	LICENSE: 
	For Appifyer, [http://www.autohotkey.net/~sumon/strictlicense.html]
	For Ini.ahk (tuncay): Thanks to tuncay for his great library, his license is linked at [http://www.autohotkey.com/forum/viewtopic.php?p=280883]
	Icons are in many cases selfmade, in other cases downloaded from http://www.iconfinder.com from Iconpacks with WTF public license. Huge thanks to the authors of Brightset icon pack.
	
	Script created using Autohotkey [http://www.autohotkey.com], AHK_L by Lexikos
*/
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#SingleInstance, Force

/*****************
** Autoexecute  **
******************
*/
FileCreateDir, Engines
FileInstall, engines\appify.exe, engines\appify.exe
;~ OnMessage(617070, "app_Appify") ; Not working atm
;~ #include C:\Program Files (x86)\AutoHotkey\Lib\ini.ahk
;~ #include C:\Program Files (x86)\AutoHotkey\Lib\notify.ahk
;~ #include C:\Program Files (x86)\AutoHotkey\Lib\tt.ahk
;~ #include C:\Program Files (x86)\AutoHotkey\Lib\addgraphicbutton.ahk
;~ #include C:\Program Files (x86)\AutoHotkey\Lib\struct.ahk
#Include inc\vars.ahk ; Defines global variables, such as img_GuiHeader
#include inc\traymenu.ahk ; Adds a Traymenu
ini_load(AppifyerApps, ini_Apps) ; Is also declared in DefineHotkeys
ini_load(AppifyerSettings, ini_Settings)
app_LaunchCount("Appifyer")


Gosub, DefineHotkeys
If (ini_getValue(AppifyerSettings, "General", "Notifications") != "Disabled")
	Notify("Appifyer:", "Appifyer (v " . ScriptVersion . ") has been launched", 2,, Img_AppifyerIcon)
If (ini_getValue(AppifyerSettings, "General", "AutoUpdate") != "Disabled")
	SetTimer, Update, -2000

#If MouseIsOver("ahk_class Button") ; Has to be explicitly defined. 
MButton:: 
Gosub, AppMenu ; Calls AppMenu, which in its' turn responds to being called by MButton and displays another "Start Menu"
return 
#If ; End #
/****************
** Subroutines **
*****************
*/
return
; INCLUDES

#Include inc\Appmenu.ahk ; Subs: AppMenu: & AppMenuRun:
#Include inc\GUIfuncs.ahk ; Every GUI related function and label f"unctions"
#include inc\definehotkeys.ahk ; Is called when hotkeys need to be updated
#include inc\feedback.ahk ; Feedback function

HotkeyRun: ; Run App from hotkey
RunApp: 
; Todo, add support for many apps from one hotkey
; Initiate transformation to variable:
StringReplace, AppToRun, A_ThisHotkey, #, Win ; To make WKHK variablesafe
StringReplace, AppToRun, AppToRun, ^, Ctrl
StringReplace, AppToRun, AppToRun, !, Alt
StringReplace, AppToRun, AppToRun, +, Shift ; Now the string should look like "WinCtrlB", to use with previously set hotkey from HotkeyApps
; Note: "AppToRun" is here a string in the form of "WinCtrlB", while the contents of the variable "WinCtrlB" is a file
AppToRunFile := %AppToRun% ; AppToRun := [path] was assined previously
App := ApptorunName%AppToRun%
app_LaunchCount(App)
SplitPath, ApptoRunFile,,,, AppNoExt
Process, Exist, %AppNoExt%.exe
ProcessError := Errorlevel
If (!ProcessError)
	Run, %AppToRunFile%,,, App_PID
else
{	
	SoundPlay, %A_WinDir%\Media\ding.wav
	WinActivate, ahk_pid %ProcessError%
	return
}
If (ini_getValue(AppifyerSettings, "General", "Notifications") != "Disabled")
	Notify("Appifyer", "Launching " . App, 3,, ApptoRunFile) ; Fix the icon
return

/***************
**    GUI     **
****************
*/

AppSettings:
#include inc\settings.ahk
return

GUIChangeAutoUpdate:
AutoUpdate := ini_getValue(AppifyerSettings, "General", "AutoUpdate")
If (Appi_SoundsON AND FileExist(Sound_Click))
	SoundPlay, %Sound_Click%
If (AutoUpdate = "Enabled")
{
	ini_replaceValue(AppifyerSettings, "General", "AutoUpdate", "Disabled")
	GuiControl,, Btn_AutoUpdate, % img_GuiBtnOff
}
else
{
	ini_replaceValue(AppifyerSettings, "General", "AutoUpdate", "Enabled")
	GuiControl,, Btn_AutoUpdate, % img_GuiBtnOn
}
return

UpdateGUI: ; Triggered by the Notify(), makes sure the GUI gets shown
Update:
; Check version 
OutOfDateApps := "" ; Clear
If (!ConnectedToInternet())
{
	Notify("No connection", "You do not seem to have a working internet connection`,`nso Appifyer will not even try to update.", 3)
	return
}
Gui, 2:Default
Gui, Destroy
Gui, Color, ffFFff
Gui, Font, s10, Verdana
Gui, Add, Pic,, % img_GuiHeaderUpdate
AllAppsIni := app_getData_ini("all") ; From online
AllAppsLocal := ini_getAllSectionNames(AppifyerApps) ; From locally
Sort, AllAppsLocal, D`,
AllAppsLocal := "Appifyer`," . AllAppsLocal
Loop, Parse, AllAppsLocal, `,
{
	App := A_LoopField
	Gui, Add, Text, x20, %App%
	Version := app_VersionCheck_ini(App, AllAppsIni)
	OldVersion := (App = "Appifyer" ? ScriptVersion : app_data(App, "Version"))
	If (Version != 0)
	{
		vApp := varSafe(App)
		Version_%vApp% := Version, prevVersion_%vApp% := app_Data(App, "Version")
		Gui, Add, Pic, yp x143 yp-1 gUpdateApp vUpdate%vApp%, %Img_Sync%
		++OutOfDateApps ; For later use
	}
	else if (!InStr(AllAppsIni, App)) ; Information unknown
		Gui, Add, Pic, yp x143 yp-1, %Img_Unknown%
	else
		Gui, Add, Pic, yp x143 yp-1, %Img_OK%
	Color := ((Version != 0) ? "93220b" : "596a5a")
	Gui, Font, c%Color% w700
	Gui, Add, Text, x234 yp-1, % ((App = "Appifyer")?(ScriptVersion):(app_Data(App, "Version") ? Round(app_Data(App, "Version"), 2) : ""))
	Gui, Font, cDefault Norm
}
Gui, Add, Button, x10 w160 yp+40 gGuiClose, Done
Gui, Add, Button, x180 w100 yp gGuiUpdateHelp, Help

If (A_ThisLabel = "UpdateGUI" OR (A_GuiControl AND (OutOfDateApps > 0)))
{
	Gui, Show
}
else if (ini_getValue(AppifyerSettings, "General", "Notifications") != "Disabled") OR (A_GuiControl)
{
	If (OutOfDateApps)
		Notify("Update...", OutOfDateApps . " app" . (OutOfDateApps>1 ? "s are" : " is") . " out of date. Click here to read more.", 5, "AC=UpdateGUI", Img_Sync)
	else
		Notify("Up to date!", "All your apps are up to date!", 3, "AC=UpdateGUI", Img_OK_Large)
}
return

GuiUpdateHelp:
MsgBox, 32, About Appifyer Update, Appifyer update syncs any known information about your apps' version towards the Appifyer database`, to detect if you need to update something. `n`nTo update`, click the "sync" button next to the app that needs to be updated.`n`nNon-Appifyer app versions can not be detected`, so they have a questionmark next to them.
return

UpdateApp:
StringTrimLeft, App, A_GuiControl, 6 ; (-) Update
prevVersion := prevVersion_%App%, version := Version_%App%
GuiControl,, %A_GuiControl%, %Img_BlackUpdate%
uApp := VarUnsafe(App)
;~ MsgBox, 68, Update %uApp%?, Current version: %prevVersion%`nAvailable version: %Version%
;~ If (ErrorLevel)
	;~ return
Location := app_Data(uApp, "File")
StringLower, lowApp, uApp
If (App = "Appifyer")
{
	RegRead, OCI, HKEY_CLASSES_ROOT, Appify\shell\open\command
	OCI_status := ((OCI != "")?"Active":"Inactive")
	If (OCI_status = "Active")
		Run, Appify:Appifyer
	else
		Notify("Error while updating " . uApp, "To update Appifyer, One-click-install must be properly enabled", 3,, Img_Error)
	return
}
UrlDownloadToFile, http://www.appifyer.com/apps/app/%lowApp%/%uApp%.exe, %Location%
If (!FileExist(Location))
{
	Notify("Error while updating " . uApp, uApp . " could not be updated.`nTry again or update manually", 3,, Img_Error)
	GuiControl,, %A_GuiControl%, %Img_Error%
	return
}
ini_replaceValue(AppifyerApps, uApp, "Version", Version)
ini_save(AppifyerApps, ini_Apps)
GuiControl,, %A_GuiControl%, %Img_OK_Large%
Notify("Updated " . uApp, uApp . " was succesfully updated to version " . Version, 3,, Img_OK_Large)
return

Exit:
ExitApp
return

#f5:: ; Only for testing, really
reload




/***************
**Installation**
****************
*/

/***************
** Functions  **
****************
*/
#Include inc\functions.ahk