#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir, %A_ScriptDir%
#SingleInstance, Force

FileCreateDir, data
FileInstall, data\badge_default.png

arg1 = %1% ; NOTE! NOT AHKv2 compliant!
RegExMatch(A_ScriptDir, "^(.*)\\", AppifyerDir) ; Go up one directory
AppifyerDir := AppifyerDir1
;~ StringTrimLeft, App, Arg1, 7 ; (-7) Appify:
StringReplace, App, Arg1, Appify:,, All
SplitPath, App,,,, App ; OutNameNoExt
;~ StringUpper, AppTitle, App, T ; Converts to title case
StringLower, AppLow, App ; Lower case (for file dir?)
If (App = "Appifyer")
 Gosub, UpdateAppifyer
; FileName & FileFullPath are defined later

Icon := (A_ScriptName = "appify.ahk" ? "appify.exe" : A_ScriptName)
Menu, Tray, Icon, %A_ScriptName%
Menu, Tray, Tip, Appify - An installer for Appifyer apps
Menu, Tray, NoStandard
Menu, Tray, Add, Appifyer.com, GoToAppifyer
If (FileExist(AppifyerDir . "\data\img\ico\appifyer.ico"))
 Menu, Tray, Icon, Appifyer.com, %AppifyerDir%\data\img\ico\appifyer.ico,, 32
Menu, Tray, Add, Exit
If (FileExist(AppifyerDir . "\data\img\ico\exit.ico"))
 Menu, Tray, Icon, Exit, %AppifyerDir%\data\img\ico\exit.ico,, 32
If (!arg1)
{
 MsgBox, 48, Attention!, Appify is a help app for Appifyer`, and acts as a file installer for the custom URI "appify:Appname". `n`nIn order do use it`, visit http://www.appifyer.com/apps and click the "One-click-installation" button for the app you wish to install.
 ExitApp
}


If FileExist(FileFullPath)
{
    Gui, 2:Default
	Gui, Color, ffFFff
    Gui, Add, Pic, x10 w32 h32, %FileFullPath%
    Gui, Font, s10, Verdana
    Gui, Add, Text, x48 yp+6, %App% is already installed!
    Gui, Add, Text, x18, Do you wish to sync with Appifyer.com`nand replace it with the latest version?
    Gui, Add, Button, x10 yp+50 w145 h30 gAccept, &Cancel ; It actually acts as a GuiClose
    Gui, Add, Button, x165 yp w145 h30 gHelp, &Help
    Gui, Add, Button, x10 w300 h30 gAccept Default, &Update
    Gui, Show,, Update: %App%
    return
}

; // Start AppInfo (This needs to be optimized better!)

/* UrlDownLoadToFile, http://www.appifyer.com/apps/appinfo.php?app=%app%, data\appinfo.ini
FileRead, appinfo, data\appinfo.ini
StringReplace, appinfo, appinfo, <br>, `r, All ; Finalize the ini
FileDelete, data\appinfo.ini 
*/

AppInfo := app_GetData_ini(App)

;~ FileAppend, %appinfo%, data\appinfo.ini ;~ No need: The variable is already an ini file
;~ ini_load(AppInfo, "data\appinfo.ini") 
Mode := ini_getValue(AppInfo, App, "Mode")
Hotkey := ini_getValue(AppInfo, App, "Hotkey")
Installation := ini_getValue(AppInfo, App, "Installation")

; // End AppInfo

Gui, 1:Default
Gui, Color, ffFFff
FileCreateDir, data
UrlDownloadToFile, http://www.appifyer.com/apps/app/%AppLow%/%AppLow%_badge.png, data\badge_temp.png
Img := ((DownloadSuccess("data\badge_temp.png") = 404)?"data\badge_default.png":"data\badge_temp.png") ; Display badge if it was downloaded
Gui, Add, Pic, x10 w32 h32, %Img%
Gui, Font, s14, Verdana
Gui, Add, Text, x48 yp+4, Appify %App%?
Gui, Font, s10, Verdana
If (Hotkey)
 Gui, Add, Text, x48, Hotkey: %Hotkey%
Gui, Add, Button, x10 w80 h30 gAccept, &Cancel ; It actually acts as a GuiClose
Gui, Add, Button, x100 yp w120 h30 gAccept, &Appify
Gui, Add, Button, x230 yp w80 h30 gHelp, &Help
Gui, Add, Button, x10 w300 h40 gAccept Default, Appify && &Run
;~ Gui, Add, Button, x10 w300 h30 gAccept Default, &Download
Gui, Show,, Appify: %App%
return

Help:
MsgBox, 32, Appify help, Appify is launched by clicking a "appify:App" link`, and you will always be asked what action to take. All apps are downloaded from Appifyer.com.`n`nInstalled apps go to your Appifyer/Apps folder.
return

Accept:
Gui, Submit
If (A_GuiControl = "&Cancel")
 ExitApp
If (A_GuiControl = "Appify && &Run")
 RunWhenDone := 1, AppifyWhenDone := 1
If (A_GuiControl = "&Appify")
 RunWhenDone := 0, AppifyWhenDone := 1
 ;~ Notify("Appify:", "Installation is not yet implemented - downloading instead...", 3,, AppifyerDir . "\data\img\ico\appifyer.ico")
If (A_GuiControl = "&Download") ; Nothing special
 AppifyWhenDone := 0
If (A_GuiControl = "&Update")
 Notify("Appify:", "Updating " . App, 3,, AppifyerDir . "\data\img\ico\appifyer.ico")
else
 Notify("Appify:", "Installing " . App . " to your Appifyer\Apps directory", 3,, AppifyerDir . "\data\img\ico\appifyer.ico")

AcceptUpdate: 

FileDir := "Apps\" . App ; Relative to Appifyer
FileFullDir := AppifyerDir . "\" . FileDir ; Absolute

If (Installation = "zip")
{
 URL := "http://www.appifyer.com/apps/app/" . AppLow . "/" . App . ".zip"
 FileName := FileDir "\" . App . ".zip"
}
else ; Installation = exe
{
  URL := "http://www.appifyer.com/apps/app/" . AppLow . "/" . App . ".exe"
  FileName := FileDir . "\" . App . ".exe"
}
FileNameExe := FileDir . "\" . App . ".exe"
FileCreateDir, %AppifyerDir%\Apps\%App%
FileFullPath := AppifyerDir . "\" . FileName
FileFullPathExe := AppifyerDir . "\" . FileNameExe

UrlDownloadToFile, %URL%, %FileFullPath%
If (DownloadSuccess(FileFullPath) = 404) ; If app didn't exist
{
 FileDelete, %FileFullPath%
 MsgBox, 16, Error! Invalid app, The app you tried to download does not exist on Appifyer`, or another error occured. Check the link or contact the author of the app`, or Appifyer support.
 ExitApp
}

If (Installation = "Zip")
{
 UnZ(FileFullPath, FileFullDir)
 FileDelete, %FileFullPath% ; Delete the zip file
}
 
Process, Exist, Appifyer.exe
Appifyer_ID := Errorlevel

 If ((AppifyWhenDone = 1) AND Appifyer_ID) ; TEMPFIX BELOW!
 {
  ;~ FileAppend, [%App%]`nFile=%FileFullPath%`nHotkey=%Hotkey%, %A_Temp%\appifyer_newapp.ini
  FileAppend, `r[%App%]`nFile=%FileFullPath%`nVersion=%Version%`nHotkey=%Hotkey%`r, %AppifyerDir%\data\appifyerapps.ini
  Process, Exist, Appifyer.exe *32
  If (!ErrorLevel)
 Process, Close, Appifyer.exe *32
 Process, Exist, Appifyer.exe *32
 If (!ErrorLevel)
 Process, Close, Appifyer.exe
 Run, %AppifyerDir%\Appifyer.exe
  ;~ Postmessage, 617070, 2,,, Appifyer.exe 
 }
;~ Notify("Download complete!", "Downloaded " . App . " (from Appifyer.com)", 1,, FileFullPath)
Notify("Download complete!", "Downloaded " . App . " (from Appifyer.com)", 1,, "data\badge_temp.png")
If (RunWhenDone = 1)
 Run %FileFullPathExe%
Sleep 1000
Gosub, Exit

~Esc::
GuiClose:
Exit: 
ExitApp

UpdateAppifyer: ; Triggered if app is "Appifyer"
;~ Process, Close, Appifyer.exe
Process, Close, Appifyer.exe *32
FileDelete, %AppifyerDir%\Appifyer.exe
UrlDownloadToFile, http://www.appifyer.com/apps/app/appifyer/Appifyer.exe, %AppifyerDir%\Appifyer.exe
Run, %AppifyerDir%\Appifyer.exe
ExitApp ; Exit
return

GoToAppifyer:
run, http://www.appifyer.com/apps
return

DownloadSuccess(File)
{
  FileRead, Var, %File%
  If (InStr(Var, "Error 404"))
   return 404
  else
   return Success
}

app_GetData(App, Query) ; "Zizorz", "Hotkey"
{
	URL      := "http://www.appifyer.com/apps/appinfo.php?app=" . App
	length := httpQuery(IniQuery,URL)
	varSetCapacity(IniQuery,-1)
	StringReplace, IniQuery, IniQuery, <br>, `r, All ; Turns it into ini instead of html
	Value := ini_getValue(IniQuery, App, Query)
	return Value
}

app_GetData_ini(App) ; Same as above, but only returns the ini
{
	URL      := "http://www.appifyer.com/apps/appinfo.php?app=" . App
	length := httpQuery(IniQuery,URL)
	varSetCapacity(IniQuery,-1)
	StringReplace, IniQuery, IniQuery, <br>, `r, All ; Turns it into ini instead of html
	return IniQuery
}


/*
CUSTOM FUNCTION by SKAN: InternetDownloadtoVar
*/

InternetFileRead( ByRef V, URL="", RB=0, bSz=1024, DLP="DLP", F=0x84000000 ) {
 Static LIB="WININET\", QRL=16, CL="00000000000000", N=""
 If ! DllCall( "GetModuleHandle", Str,"wininet.dll" )
      DllCall( "LoadLibrary", Str,"wininet.dll" )
 If ! hIO:=DllCall( LIB "InternetOpenA", Str,N, UInt,4, Str,N, Str,N, UInt,0 )
   Return -1
 If ! (( hIU:=DllCall( LIB "InternetOpenUrlA", UInt,hIO, Str,URL, Str,N, Int,0, UInt,F
                                                            , UInt,0 ) ) || ErrorLevel )
   Return 0 - ( !DllCall( LIB "InternetCloseHandle", UInt,hIO ) ) - 2
 If ! ( RB  )
 If ( SubStr(URL,1,4) = "ftp:" )
    CL := DllCall( LIB "FtpGetFileSize", UInt,hIU, UIntP,0 )
 Else If ! DllCall( LIB "HttpQueryInfoA", UInt,hIU, Int,5, Str,CL, UIntP,QRL, UInt,0 )
   Return 0 - ( !DllCall( LIB "InternetCloseHandle", UInt,hIU ) )
            - ( !DllCall( LIB "InternetCloseHandle", UInt,hIO ) ) - 4
 VarSetCapacity( V,64 ), VarSetCapacity( V,0 )
 SplitPath, URL, FN,,,, DN
 FN:=(FN ? FN : DN), CL:=(RB ? RB : CL), VarSetCapacity( V,CL,32 ), P:=&V,
 B:=(bSz>CL ? CL : bSz), TtlB:=0, LP := RB ? "Unknown" : CL,  %DLP%( True,CL,FN )
 Loop {
       If ( DllCall( LIB "InternetReadFile", UInt,hIU, UInt,P, UInt,B, UIntP,R ) && !R )
       Break
       P:=(P+R), TtlB:=(TtlB+R), RemB:=(CL-TtlB), B:=(RemB<B ? RemB : B), %DLP%( TtlB,LP )
       Sleep -1
 } TtlB<>CL ? VarSetCapacity( T,TtlB ) DllCall( "RtlMoveMemory", Str,T, Str,V, UInt,TtlB )
  . VarSetCapacity( V,0 ) . VarSetCapacity( V,TtlB,32 ) . DllCall( "RtlMoveMemory", Str,V
  , Str,T, UInt,TtlB ) . %DLP%( TtlB, TtlB ) : N
 If ( !DllCall( LIB "InternetCloseHandle", UInt,hIU ) )
  + ( !DllCall( LIB "InternetCloseHandle", UInt,hIO ) )
   Return -6
Return, VarSetCapacity(V)+((ErrorLevel:=(RB>0 && TtlB<RB)||(RB=0 && TtlB=CL) ? 0 : 1)<<64)
}
;  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; The following function is an add-on to provide "Download Progress" to InternetFileRead()
; InternetFileRead() calls DLP() dynamically, i.e., will not error-out if DLP() is missing
;  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

DLP( WP=0, LP=0, Msg="" ) {
 If ( WP=1 ) {
 SysGet, m, MonitorWorkArea, 1
 y:=(mBottom-46-2), x:=(mRight-370-2), VarSetCapacity( Size,16,0 )
 DllCall( "shlwapi.dll\StrFormatByteSize64A", Int64,LP, Str,Size, UInt,16 )
 Size := ( Size="0 bytes" ) ? N : "«" Size "»"
 Progress, CWE6E3E4 CT000020 CBF73D00 x%x% y%y% w370 h46 B1 FS8 WM700 WS400 FM8 ZH8 ZY3
         ,, %Msg%  %Size%, InternetFileRead(), Tahoma
 WinSet, Transparent, 210, InternetFileRead()
 } Progress,% (P:=Round(WP/LP*100)),% "Memory Download: " wp " / " lp " [ " P "`% ]"
 IfEqual,wP,0, Progress, Off
}
;  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; The following function is a part of: VarZ 46L - Native Data Compression
; View topic : www.autohotkey.com/forum/viewtopic.php?t=45559
;  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

VarZ_Save( byRef V, File="" ) { ;   www.autohotkey.net/~Skan/wrapper/FileIO16/FileIO16.ahk
Return ( ( hFile :=  DllCall( "_lcreat", Str,File, UInt,0 ) ) > 0 )
                 ?   DllCall( "_lwrite", UInt,hFile, Str,V, UInt,VarSetCapacity(V) )
                 + ( DllCall( "_lclose", UInt,hFile ) << 64 ) : 0
}

;  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;~ Unzip By Shajul

;  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Unz(sZip, sUnz)
{
    fso := ComObjCreate("Scripting.FileSystemObject")
    If Not fso.FolderExists(sUnz)  ;http://www.autohotkey.com/forum/viewtopic.php?p=402574
       fso.CreateFolder(sUnz)
    psh  := ComObjCreate("Shell.Application")
    zippedItems := psh.Namespace( sZip ).items().count
    psh.Namespace( sUnz ).CopyHere( psh.Namespace( sZip ).items, 4|16 )
    Loop {
     If (A_Index > 15)
    break
        sleep 50
        unzippedItems := psh.Namespace( sUnz ).items().count
        ToolTip Unzipping in progress..
        IfEqual,zippedItems,%unzippedItems%
            break
    }
    ToolTip
    return
}
