GuiClose:
TT_Remove()
Gui, Destroy
return

GuiSaveNoClose:
NoClose := "True"
GuiSubmit:
If (NoClose = "True")
	Gui, Submit, nohide
else
	Gui, Submit
Notify("Appifyer:", "Saved settings...", 3,, img_AppifyerIcon)
ini_save(AppifyerSettings, ini_Settings)
app_SaveAll()
Gosub, DefineHotkeys
return

GuiChangeName:
StringTrimRight, AppV, A_GuiControl, 5 ; _text (-)
App := varUnsafe(AppV)
InputBox, App, App name:, Change app name,,300,100,,,,, %App%
If Errorlevel
	return
AppV := varSafe(App)
If (StrLen(App) > 13)
	{
		StringLeft, AppDisplay, App, 10
		AppDisplay := AppDisplay . ".."
	}
else
	AppDisplay := App
GuiControl,, %A_GuiControl%, %AppDisplay%
%AppV%_Text := NewName

return

GuiAddApp:
FileSelectFile, AppPath, S, Apps, Please select the App you wish to add...,
If (ErrorLevel = 1)
	return
SplitPath, AppPath, Filename
StringTrimRight, FileName, FileName, 4 ; Removes .ext
InputBox, AppName, Add App, Select a name for your chosen App...,, 300, 130,,,,, %FileName%
If (ErrorLevel = 1)
	return
AddApp:
App := AppName
AppV := varSafe(App)
File := AppPath
App_AddApp(App, File)
ini_save(AppifyerApps, ini_Apps)
; No need to reload Apps data (ini, AppifyerApps), it is already updated
Gosub, AppSettings
return

GuiChangeIcon:
StringTrimRight, App, A_GuiControl, 5 ; _icon (-)
AppV := varSafe(App)
File := App_Data(App, "File")
SplitPath, File,, Dir
FileSelectFile, NewIcon, 1, %Dir%, Select a new icon for %App%, Icon or exe (*ico; *.exe)
If Errorlevel
	return
%AppV%_Icon := NewIcon
GuiControl,, %AppV%_Icon, %NewIcon%
return

GuiChangeMode:
StringTrimRight, AppV, A_GuiControl, 5 ; _mode (-)
App := varUnsafe(AppV)
Mode := %AppV%_Mode ; Before
Mode := ((Mode = "AlwaysOn")?("OnDemand"):("AlwaysOn")) ; Toggle
%AppV%_Mode := Mode ; After
Descriptive := ((Mode = "AlwaysOn")?("Always on"):("On demand")) ; Adds spaces
Traytip, Appifyer:, Toggled %App% to `"%Descriptive%`" mode, 4, 1
NewIcon := ((Mode = "AlwaysOn")?(Img_GuiModeA):(Img_GuiModeO))
GuiControl,, %A_GuiControl%, % NewIcon
return

GuiRemoveApp:
StringTrimRight, AppV, A_GuiControl, 7 ; _delete (-)
App := varUnSafe(AppV)
MsgBox, 52, Remove app?, Remove %App%?`nNote: You will only remove the app from Appifyer.
IfMsgBox, No
	return
Ini_Delete(AppifyerApps, App)
GuiControl, Hide, %AppV%_Icon
GuiControl, Disable, %AppV%_Text
GuiControl, Hide, %AppV%_Mode
GuiControl, Hide, %AppV%_Delete
GuiControl, Disable, %AppV%_Hotkey
GuiControl, Disable, %AppV%_Winkey
SoundPlay, data\sounds\paper_rip2.wav
return

GuiSetHotkey: ; Unused, will probably remain so for a while
Gui, 17:Default
Gui, Destroy
StringTrimRight, App, A_GuiControl, 10 ; _setHotkey (-)
AppV := varSafe(App)
	Gui, Add, Text,, %App% Hotkey:
	Gui, Add, Hotkey, x10 w60 v%AppV%_Hotkey, % App_Data(App, "Hotkey")
	WK := App_Data(App, "Winkey")
	Gui, Add, Checkbox, x80 yp+2 Checked%WK% v%AppV%_Winkey, Winkey?
Gui, Show
return

GuiDropFiles:  ; Support drag & drop. Most of below code is from GuiAddApp
Loop, parse, A_GuiEvent, `n
{
AppPath := A_LoopField  ; Get the first file only (in case there's more than one).
SplitPath, AppPath,,,, NameNoExt
InputBox, AppName, Add App, Select a name for the chosen app...,, 300, 130,,,,, %NameNoExt%
If (ErrorLevel = 1)
	return
File := AppPath
App_AddApp(AppName, File)
; Break ; If only adding one file
}
ini_save(AppifyerApps, ini_Apps)
Gosub, AppSettings
return

GuiHelp:
Help:
MsgBox, 32, Appifyer help, Appifyer v. %ScriptVersion% (Alpha)`nAuthor: Simon Strålberg`n`nTo run Apps, first set them up using the Settings menu. You can either add Apps manually, or drag them onto the Appifyer apps GUI. Save your changes when finished.`n`nTo launch apps, either press their associated hotkey(s), or use the Appsmenu (Default hotkey: Windows key + Spacebar). You can now click the App you want to launch`, or press the first letter in its' name.
return
NYI:
Traytip,, Not yet implemented, 4, 1
return

GuiChangeNotifications:
If (Appi_SoundsON AND FileExist(Sound_Click))
	SoundPlay, %Sound_Click%
If (ini_getValue(AppifyerSettings, "General", "Notifications") = "Enabled")
{
	ini_replaceValue(AppifyerSettings, "General", "Notifications", "Disabled")
	GuiControl,, Btn_Notifications, % img_GuiBtnOff
	;~ AddGraphicButton("AppifyerNotifications" . GB_Number, "data\img\ico\disabled.ico")
}
else
{
	ini_replaceValue(AppifyerSettings, "General", "Notifications", "Enabled")
	GuiControl,, Btn_Notifications, % img_GuiBtnOn
	;~ AddGraphicButton("AppifyerNotifications" . GB_Number, "data\img\ico\enabled.ico")	
}
return

GuiChangeAppifyerHotkey:
IniRead, PrevHotkey, %ini_Settings%, General, AppsMenuHotkey, ; Iniread, to get the actual (saved) value
InputBox, AppsMenuHotkey, Appifyer hotkey, Type an AHK compatible hotkey,, 300, 140,,,,, %AppsMenuHotkey%
ini_replaceValue(AppifyerSettings, "General", "AppsMenuHotkey", AppsMenuHotkey)
return

GuiOneClickInstall:
If (Appi_SoundsON AND FileExist(Sound_Click))
	SoundPlay, %Sound_Click%
RegRead, OCI, HKEY_CLASSES_ROOT, Appify\shell\open\command
OCI_status := ((OCI != "")?"Active":"Inactive")
RegDelete, HKEY_CLASSES_ROOT, Appify ; Clear
If (OCI_status = "Active")
{
	Notify("Appifyer", "Removed custom URI from the registry", 4,, Img_AppifyerIcon)	
	GuiControl,, Btn_OneClickInstall, % img_GuiBtnOff
	;~ AddGraphicButton("AppifyerOCI" . GB_Number, "data\img\ico\install.ico")
	return
}
RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Appify, URL Protocol, ""
RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Appify\DefaultIcon,, `"%A_ScriptDir%\Appifyer.exe,1`"
RegWrite, REG_SZ, HKEY_CLASSES_ROOT, Appify\shell\open\command,, `"%A_ScriptDir%\Engines\Appify.exe`" `"`%1`"
; Verify the registry has been read
RegRead, OCI, HKEY_CLASSES_ROOT, Appify\shell\open\command
OCI_status := ((OCI != "")?"Active":"Inactive")
If (OCI_status = "Active") ; If registry was written to
{
	Notify("Appifyer", "Added custom URI (Appify:app) to the registry", 4,, img_AppifyerIcon)
	GuiControl,, Btn_OneClickInstall, % img_GuiBtnOn
	;~ AddGraphicButton("AppifyerOCI" . GB_Number, "data\img\ico\install_a.ico")
}
else
	Notify("Appifyer", "Could not add custom URI`nTry running Appifyer as admin, and try again", 4,, Img_AppifyerIcon)
return

ChangeAutostart:
If (Appi_SoundsON AND FileExist(Sound_Click))
	SoundPlay, %Sound_Click%
IfNotExist %A_Startup%\Appifyer.lnk ; Adds Appifyer to Autostart
{	
	GuiControl,, Btn_ChangeAutostart, %Img_GuiBtnOn%
	FileCreateShortcut , %A_ScriptDir%\%A_ScriptName%, %A_Startup%\Appifyer.lnk, %A_ScriptDir%
	Notify("(+) Autostart", "Added " . A_ScriptName . " to autostart", 3)
	;~ AddGraphicButton("AppifyerAutostart" . GB_Number, "\ico\enabled.ico")
	;~ Menu, Tray, Icon, Autostart, %Img_Autostart_On%,, 32
	; Menu, SettingsMenu, Check, Autostart
}
Else
{
	GuiControl,, Btn_ChangeAutostart, %Img_GuiBtnOff%
	FileDelete, %A_Startup%\Appifyer.lnk
	Notify("(-) Autostart", "Removed " . A_ScriptName . " from autostart", 3)
;~ AddGraphicButton("AppifyerAutostart" . GB_Number, "data\img\ico\disabled.ico")
;~ Menu, Tray, Icon, Autostart, %Img_Autostart_Off%,, 32
; Menu, SettingsMenu, UnCheck, Autostart
}
return

GuiListLaunchCounts:
Gui, 30:Default
Gui, Destroy
Gui, Color, ffFFff
Gui, Font, s18, Verdana ; Header
Gui, Add, Text, x10, App            Launches
Gui, Font, s10, Verdana
ini_load(AppifyerApps, ini_Apps)
AllApps := ini_getAllSectionNames(AppifyerApps)
Sort, AllApps, D`,
Loop, Parse, AllApps, `,
{
	App := A_LoopField
	Gui, Add, Text, x10, %App%
	Gui, Add, Text, x200 yp, % app_LaunchCount(App, "0")
}
Gui, Show
Return

Visit:
If (A_GuiControl = "OnlineAppifyer")
	Run, http://www.appifyer.com
If (A_GuiControl = "OnlineAutohotkey")
	Run, http://www.autohotkey.com
If (A_GuiControl = "OnlineHelp" OR A_ThisMenuItem = "Help")
	Run, http://www.appifyer.com/apps/app/appifyer/Appifyer`%20help.pdf
If (A_GuiControl = "OnlineLicense")
	Run, http://www.autohotkey.net/~sumon/strictlicense.html
return