app_data(AppName, key) ; Returns key value
{
	global AppifyerApps
	value := ini_getValue(AppifyerApps, AppName, key)
	return value
}

app_GetData(App, Query) ; "Zizorz", "Hotkey" (gets data from Appifyer.com using $_GET)
{
	URL      := "http://www.appifyer.com/apps/appinfo.php?app=" . App
	length := httpQuery(IniQuery,URL)
	varSetCapacity(IniQuery,-1)
	StringReplace, IniQuery, IniQuery, <br>, `r, All ; Turns it into ini instead of html
	Value := ini_getValue(IniQuery, App, Query)
	return Value
}

app_GetData_ini(App) ; Same as above, but only returns the ini. Specify app as "all" to return all apps.
{
	URL      := "http://www.appifyer.com/apps/appinfo.php?app=" . App
	length := httpQuery(IniQuery,URL)
	varSetCapacity(IniQuery,-1)
	StringReplace, IniQuery, IniQuery, <br>, `r, All ; Turns it into ini instead of html
	return IniQuery
}

app_LaunchCount(App, Increment = 1) ; Input an app to increase count by 1, input App, 0 to just check the LaunchCount
{
	global Ini_Apps, Ini_Settings
	Ini := ((App = "Appifyer")?(Ini_Settings):(Ini_Apps)), Sect := ((App = "Appifyer")?("General"):(App))
	IniRead, LaunchCount, %Ini%, %Sect%, LaunchCount, 0
	LaunchCount := LaunchCount + Increment
	IniWrite, %LaunchCount%, %Ini%, %Sect%, LaunchCount
	return LaunchCount
}

app_SaveAll()
{
	global AppifyerApps, ini_Apps
	GoSub, SaveAllHelper
	return
}

SaveAllHelper: ; Tempfix to access global variables dynamically
Null := "" ;
SectionNames := ini_getAllSectionNames(AppifyerApps)
Sort, Sectionnames, D`,
Loop, Parse, SectionNames, `,
{
	App := A_LoopField
	AppV := varSafe(App)
	;~ ini_replaceValue(AppifyerApps, App, "File", %AppV%_File)
	if (%AppV%_Winkey = 1)
		WK := "#"
	else
		WK := "" ; Null
	ini_replaceValue(AppifyerApps, App, "Hotkey", WK . %AppV%_Hotkey)
	ini_replaceValue(AppifyerApps, App, "Winkey", Null) ; Resets to 0
	ini_replaceValue(AppifyerApps, App, "Icon", %AppV%_Icon)
	ini_replaceValue(AppifyerApps, App, "Mode", %AppV%_Mode)
}
ini_save(AppifyerApps, ini_Apps)

return

app_AddApp(App, File, FilePathType="", Version="", Active="1", Mode="OnDemand", LaunchCount="0", Icon="", Hotkey="")
{
	global AppifyerApps
	If Instr(File, A_ScriptDir) ; It most probably will be
	{
		StringReplace, File, File, %A_ScriptDir%,, 1 ; Relativize
		StringTrimLeft, File, File, 1 ; Remove \
		FilePathType := "Relative"
	}
	ini_insertSection(AppifyerApps, App, "File=" . File . "`nFilePathType=" . FilePathType . "`nVersion=" . Version . "`nActive=" . Active . "`nMode=" . Mode . "`nLaunchCount=" . LaunchCount . "`nIcon=" . Icon . "`nHotkey=" . Hotkey)
	return
}

app_Appify() ; Input comes from %tmp%
{
	ini_load(Ini, A_Temp . "\appifyer_newapp.ini")
	do_hotkey := wParam
	msgbox %ini%
	return
}

app_VersionCheck(App) ; Checks the app version against online version
{
	global ScriptVersion
	OnlineVersion := App_getData(App, "Version")
	AppVersion := (app_data(App, "Version")?app_data(App, "Version"):"Unknown")
	Version := ((App = "Appifyer")? ScriptVersion : AppVersion)
	ReturnValue := ((OnlineVersion > Version) ? OnlineVersion : 0)
	return ReturnValue
}

app_VersionCheck_ini(App, Ini) ; Checks the app version against local version - Faster, since it only downloads the ini once
{
	global ScriptVersion
	OnlineVersion := ini_getValue(Ini, App, "Version")
	AppVersion := (app_data(App, "Version")?app_data(App, "Version"):0)
	Version := ((App = "Appifyer")? ScriptVersion : AppVersion)
	ReturnValue := ((OnlineVersion > Version) ? OnlineVersion : 0)
	return ReturnValue ; Outputs 0 if up-to-date, else new version number
}

varSafe(String)
{
	
	StringReplace, String, String, %A_Space%, _, All
	return String
}

varUnSafe(String)
{
	StringReplace, String, String, _, %A_Space%, All
	return String
}

; AHK non-appifyer functions

ConnectedToInternet(flag=0x40) { 
Return DllCall("Wininet.dll\InternetGetConnectedState", "Str", flag,"Int",0) 
}

MouseIsOver(WinTitle) { ; Used for the MButton @ Start menu
    MouseGetPos,,, Win
    return WinExist(WinTitle . " ahk_id " . Win)
}